package me.Demon.DemonWarpPro;

import com.google.common.io.ByteArrayDataInput;
import com.google.common.io.ByteArrayDataOutput;
import com.google.common.io.ByteStreams;
import me.Demon.DemonWarpPro.AtpEvent.AtpListener;
import me.Demon.DemonWarpPro.AtpEvent.AtpPluginMessageListener;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.java.JavaPlugin;
import org.bukkit.plugin.messaging.PluginMessageListener;

import java.util.ArrayList;
import java.util.List;

public final class Main extends JavaPlugin implements PluginMessageListener {
    public static Main plugin;
    public static String prefix = "§7[§6战争领域§7] §f";
    public static List<String> Spigot_Warp_List = new ArrayList<>();

    public void onEnable() {
        plugin = this;
        this.saveDefaultConfig();
        if (this.getConfig().getString("SpigotWarp") != null) {
            Spigot_Warp_List.addAll(this.getConfig().getConfigurationSection("SpigotWarp").getKeys(false));
        }

        this.getServer().getMessenger().registerOutgoingPluginChannel(this, "bungee:warp");
        this.getServer().getMessenger().registerIncomingPluginChannel(this, "bungee:warp", this);
        Bukkit.getConsoleSender().sendMessage("§e[坐标] §r载入本地坐标: " + Spigot_Warp_List.size() + "个");
        Bukkit.getConsoleSender().sendMessage("§e[坐标] §r正在启动插件...");
        Bukkit.getServer().getMessenger().registerIncomingPluginChannel(plugin, "bungee:atp", new AtpPluginMessageListener());
        Bukkit.getPluginManager().registerEvents(new AtpListener(), plugin);
        Bukkit.getConsoleSender().sendMessage("§e[跨服Atp] §r正在启动插件...");
    }

    public void onDisable() {
        Bukkit.getConsoleSender().sendMessage("§e[坐标] §r正在关闭插件...");
    }

    public boolean onCommand(CommandSender sender, Command cmd, String Command, String[] args) {
        if (Command.equalsIgnoreCase("spawn") && sender instanceof Player) {
            WarpAPI.tp_SpigotAndBungee_Warp((Player)sender, "主城");
        }

        String warp_key;
        if (Command.equalsIgnoreCase("warp") && sender instanceof Player && args.length == 1) {
            warp_key = args[0];
            WarpAPI.tp_SpigotAndBungee_Warp((Player)sender, warp_key);
        }

        if (Command.equalsIgnoreCase("warpadmin") && sender.isOp()) {
            if (args.length == 2 && args[0].equalsIgnoreCase("save")) {
                if (sender instanceof Player) {
                    warp_key = args[1];
                    WarpAPI.Save_Spigot_Warp((Player)sender, warp_key);
                }
            } else if (args.length == 2 && args[0].equalsIgnoreCase("shan")) {
                warp_key = args[1];
                WarpAPI.Remove_Spigot_Warp(sender, warp_key);
            } else if (args.length == 1 && args[0].equalsIgnoreCase("Updata")) {
                if (sender instanceof Player) {
                    Player p = (Player)sender;
                    StringBuilder str = new StringBuilder();

                    for (String warp_name : Spigot_Warp_List) {
                        ByteArrayDataOutput out = ByteStreams.newDataOutput();
                        out.writeUTF("bungee:warpupdata");
                        out.writeUTF(warp_name);
                        p.sendPluginMessage(this, "bungee:warp", out.toByteArray());
                        str.append(warp_name).append("§f,§a");
                    }

                    p.sendMessage(prefix + "坐标数据已上传: §a" + str);
                }
            } else {
                this.CommandHelp(sender);
            }
        }

        return false;
    }

    public void CommandHelp(CommandSender sender) {
        sender.sendMessage("");
        sender.sendMessage("§e------- ======= §6魂式坐标 §e======= -------");
        sender.sendMessage("§2/warpadmin Updata §f- §2上传数据至BC");
        sender.sendMessage("§2/warpadmin save §e[坐标] §f- §2设置坐标");
        sender.sendMessage("§2/warpadmin shan §e[坐标] §f- §2删除坐标");
        sender.sendMessage("§e------- ======= §6魂式坐标 §e======= -------");
    }

    public void onPluginMessageReceived(String channel, Player player, byte[] message) {
        if (channel.equals("bungee:warp")) {
            final ByteArrayDataInput in = ByteStreams.newDataInput(message);
            String pindao = in.readUTF();
            if (pindao.equals("spigot:warptp")) {
                String name = in.readUTF();
                final Player player1 = Bukkit.getPlayerExact(name);
                if (player1 != null) {
                    Bukkit.getScheduler().runTaskLater(plugin, new Runnable() {
                        public void run() {
                            String warp_Name = in.readUTF();
                            WarpAPI.tp_Spigot_Warp(player1, warp_Name);
                        }
                    }, 5L);
                }
            }
        }

    }
}
