package me.Demon.DemonWarpPro.AtpEvent;

import java.util.HashMap;
import java.util.Map;
import java.util.UUID;
import me.Demon.DemonWarpPro.Main;
import me.Demon.DemonWarpPro.WarpAPI;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerJoinEvent;

public class AtpListener implements Listener {
    public static Map<UUID, UUID> tpaMap = new HashMap<>();

    @EventHandler
    public void onPlayerJoin(PlayerJoinEvent event) {
        Player player = event.getPlayer();
        if (tpaMap.containsKey(player.getUniqueId())) {
            UUID uuid = tpaMap.get(player.getUniqueId());
            Player player1 = Bukkit.getPlayer(uuid);
            tpaMap.remove(player.getUniqueId());
            if (player1 != null && player1.isOnline()) {
                if (player1.getWorld().getName().contains("fuben_")) {
                    Bukkit.getScheduler().runTaskLater(Main.plugin, () -> {
                        WarpAPI.tp_Spigot_Warp(player, "副本区1");
                        player.sendMessage(Main.prefix + "对方所在位置无法将你传送过去.");
                    }, 2L);
                } else if (player1.getWorld().getName().equalsIgnoreCase("paoku")) {
                    Bukkit.getScheduler().runTaskLater(Main.plugin, () -> {
                        WarpAPI.tp_Spigot_Warp(player, "跑酷区");
                        player.sendMessage(Main.prefix + "对方所在位置无法将你传送过去.");
                    }, 2L);
                } else {
                    Bukkit.getScheduler().runTaskLater(Main.plugin, () -> {
                        player.teleport(player1.getLocation());
                    }, 2L);
                }
            }
        }

    }
}
