package me.Demon.DemonWarpPro.AtpEvent;

import com.google.common.io.ByteArrayDataInput;
import com.google.common.io.ByteStreams;
import java.util.UUID;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;
import org.bukkit.plugin.messaging.PluginMessageListener;

public class AtpPluginMessageListener implements PluginMessageListener {

    public void onPluginMessageReceived(String s, Player player, byte[] bytes) {
        if (s.equals("bungee:warp")) {
            ByteArrayDataInput in = ByteStreams.newDataInput(bytes);
            String subchannel = in.readUTF();

            try {
                if (subchannel.equalsIgnoreCase("accept")) {
                    String playerUUID1 = in.readUTF();
                    String playerUUID2 = in.readUTF();
                    UUID uuid1 = UUID.fromString(playerUUID1);
                    UUID uuid2 = UUID.fromString(playerUUID2);
                    boolean flag = in.readBoolean();
                    if (flag) {
                        Player player1 = Bukkit.getPlayer(uuid1);
                        Player player2 = Bukkit.getPlayer(uuid2);
                        if (player1 != null && player1.isOnline() && player2 != null && player2.isOnline()) {
                            player2.teleport(player1.getLocation());
                        }
                    } else {
                        AtpListener.tpaMap.put(uuid2, uuid1);
                    }
                }
            } catch (Exception var13) {
                var13.printStackTrace();
            }

        }
    }
}
